/* preferences-dialog.c generated by valac 0.42.6, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/*
 * Copyright (C) 2009-2017 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>,
 *         Eduard Gotwig <g@ox.io>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>


#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef enum  {
	SCAN_TYPE_SINGLE,
	SCAN_TYPE_ADF_FRONT,
	SCAN_TYPE_ADF_BACK,
	SCAN_TYPE_ADF_BOTH,
	SCAN_TYPE_BATCH
} ScanType;


#define TYPE_SCAN_TYPE (scan_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SCAN_DEVICE (scan_device_get_type ())
#define SCAN_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_DEVICE, ScanDevice))
#define SCAN_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_DEVICE, ScanDeviceClass))
#define IS_SCAN_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_DEVICE))
#define IS_SCAN_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_DEVICE))
#define SCAN_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_DEVICE, ScanDeviceClass))

typedef struct _ScanDevice ScanDevice;
typedef struct _ScanDeviceClass ScanDeviceClass;
typedef struct _ScanDevicePrivate ScanDevicePrivate;

#define TYPE_PAGE_ICON (page_icon_get_type ())
#define PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_ICON, PageIcon))
#define PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_ICON, PageIconClass))
#define IS_PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_ICON))
#define IS_PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_ICON))
#define PAGE_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_ICON, PageIconClass))

typedef struct _PageIcon PageIcon;
typedef struct _PageIconClass PageIconClass;
typedef struct _PageIconPrivate PageIconPrivate;
enum  {
	PAGE_ICON_0_PROPERTY,
	PAGE_ICON_NUM_PROPERTIES
};
static GParamSpec* page_icon_properties[PAGE_ICON_NUM_PROPERTIES];

struct _PreferencesDialog {
	GtkDialog parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	GtkDialogClass parent_class;
};

struct _PreferencesDialogPrivate {
	GSettings* settings;
	gboolean setting_devices;
	gboolean user_selected_device;
	GtkComboBox* device_combo;
	GtkComboBox* text_dpi_combo;
	GtkComboBox* photo_dpi_combo;
	GtkComboBox* paper_size_combo;
	GtkScale* brightness_scale;
	GtkScale* contrast_scale;
	GtkListStore* device_model;
	GtkRadioButton* page_delay_3s_button;
	GtkRadioButton* page_delay_5s_button;
	GtkRadioButton* page_delay_7s_button;
	GtkRadioButton* page_delay_10s_button;
	GtkRadioButton* page_delay_15s_button;
	GtkListStore* text_dpi_model;
	GtkListStore* photo_dpi_model;
	GtkRadioButton* front_side_button;
	GtkRadioButton* back_side_button;
	GtkRadioButton* both_side_button;
	GtkListStore* paper_size_model;
	GtkAdjustment* brightness_adjustment;
	GtkAdjustment* contrast_adjustment;
};

struct _Block7Data {
	int _ref_count_;
	PreferencesDialog* self;
	GSettings* settings;
};

struct _ScanDevice {
	GObject parent_instance;
	ScanDevicePrivate * priv;
	gchar* name;
	gchar* label;
};

struct _ScanDeviceClass {
	GObjectClass parent_class;
};

struct _PageIcon {
	GtkDrawingArea parent_instance;
	PageIconPrivate * priv;
};

struct _PageIconClass {
	GtkDrawingAreaClass parent_class;
};

struct _PageIconPrivate {
	gchar* text;
	gdouble r;
	gdouble g;
	gdouble b;
};


static gint PreferencesDialog_private_offset;
static gpointer preferences_dialog_parent_class = NULL;
static gint PageIcon_private_offset;
static gpointer page_icon_parent_class = NULL;

GType preferences_dialog_get_type (void) G_GNUC_CONST;
PreferencesDialog* preferences_dialog_new (GSettings* settings);
PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 GSettings* settings);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
#define DEFAULT_TEXT_DPI 150
static void preferences_dialog_set_dpi_combo (PreferencesDialog* self,
                                       GtkComboBox* combo,
                                       gint default_dpi,
                                       gint current_dpi);
static void __lambda4_ (Block7Data* _data7_);
gint preferences_dialog_get_text_dpi (PreferencesDialog* self);
static void ___lambda4__gtk_combo_box_changed (GtkComboBox* _sender,
                                        gpointer self);
#define DEFAULT_PHOTO_DPI 300
static void __lambda5_ (Block7Data* _data7_);
gint preferences_dialog_get_photo_dpi (PreferencesDialog* self);
static void ___lambda5__gtk_combo_box_changed (GtkComboBox* _sender,
                                        gpointer self);
GType scan_type_get_type (void) G_GNUC_CONST;
static void preferences_dialog_set_page_side (PreferencesDialog* self,
                                       ScanType page_side);
static void __lambda6_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda7_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda8_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda9_ (Block7Data* _data7_);
gint preferences_dialog_get_brightness (PreferencesDialog* self);
static void ___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                               gpointer self);
static void __lambda10_ (Block7Data* _data7_);
gint preferences_dialog_get_contrast (PreferencesDialog* self);
static void ___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
void preferences_dialog_set_paper_size (PreferencesDialog* self,
                                        gint width,
                                        gint height);
static void __lambda11_ (Block7Data* _data7_);
gboolean preferences_dialog_get_paper_size (PreferencesDialog* self,
                                            gint* width,
                                            gint* height);
static void ___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
void preferences_dialog_set_page_delay (PreferencesDialog* self,
                                        gint page_delay);
static void __lambda12_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda13_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda14_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda15_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda16_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
GType scan_device_get_type (void) G_GNUC_CONST;
void preferences_dialog_set_scan_devices (PreferencesDialog* self,
                                          GList* devices);
static gboolean preferences_dialog_find_scan_device (PreferencesDialog* self,
                                              const gchar* device,
                                              GtkTreeIter* iter);
gchar* preferences_dialog_get_selected_device (PreferencesDialog* self);
gchar* preferences_dialog_get_selected_device_label (PreferencesDialog* self);
void preferences_dialog_set_selected_device (PreferencesDialog* self,
                                             const gchar* device);
ScanType preferences_dialog_get_page_side (PreferencesDialog* self);
void preferences_dialog_set_brightness (PreferencesDialog* self,
                                        gint brightness);
void preferences_dialog_set_contrast (PreferencesDialog* self,
                                      gint contrast);
gint preferences_dialog_get_page_delay (PreferencesDialog* self);
static void preferences_dialog_device_combo_changed_cb (PreferencesDialog* self,
                                                 GtkWidget* widget);
static void _preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self);
static void preferences_dialog_finalize (GObject * obj);
GType page_icon_get_type (void) G_GNUC_CONST;
#define PAGE_ICON_MINIMUM_WIDTH 20
PageIcon* page_icon_new (const gchar* text,
                         gdouble r,
                         gdouble g,
                         gdouble b);
PageIcon* page_icon_construct (GType object_type,
                               const gchar* text,
                               gdouble r,
                               gdouble g,
                               gdouble b);
static void page_icon_real_get_preferred_width (GtkWidget* base,
                                         gint* minimum_width,
                                         gint* natural_width);
static void page_icon_real_get_preferred_height (GtkWidget* base,
                                          gint* minimum_height,
                                          gint* natural_height);
static void page_icon_real_get_preferred_height_for_width (GtkWidget* base,
                                                    gint width,
                                                    gint* minimum_height,
                                                    gint* natural_height);
static void page_icon_real_get_preferred_width_for_height (GtkWidget* base,
                                                    gint height,
                                                    gint* minimum_width,
                                                    gint* natural_width);
static gboolean page_icon_real_draw (GtkWidget* base,
                              cairo_t* c);
static void page_icon_finalize (GObject * obj);


static inline gpointer
preferences_dialog_get_instance_private (PreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesDialog_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 62 "../src/preferences-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 297 "preferences-dialog.c"
}


static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 62 "../src/preferences-dialog.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 62 "../src/preferences-dialog.vala"
	return _data7_;
#line 308 "preferences-dialog.c"
}


static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 62 "../src/preferences-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 319 "preferences-dialog.c"
		PreferencesDialog* self;
#line 62 "../src/preferences-dialog.vala"
		self = _data7_->self;
#line 62 "../src/preferences-dialog.vala"
		_g_object_unref0 (_data7_->settings);
#line 62 "../src/preferences-dialog.vala"
		_g_object_unref0 (self);
#line 62 "../src/preferences-dialog.vala"
		g_slice_free (Block7Data, _data7_);
#line 329 "preferences-dialog.c"
	}
}


static void
__lambda4_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
#line 96 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 96 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "text-dpi", preferences_dialog_get_text_dpi (self));
#line 342 "preferences-dialog.c"
}


static void
___lambda4__gtk_combo_box_changed (GtkComboBox* _sender,
                                   gpointer self)
{
#line 96 "../src/preferences-dialog.vala"
	__lambda4_ (self);
#line 352 "preferences-dialog.c"
}


static void
__lambda5_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
#line 101 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 101 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "photo-dpi", preferences_dialog_get_photo_dpi (self));
#line 364 "preferences-dialog.c"
}


static void
___lambda5__gtk_combo_box_changed (GtkComboBox* _sender,
                                   gpointer self)
{
#line 101 "../src/preferences-dialog.vala"
	__lambda5_ (self);
#line 374 "preferences-dialog.c"
}


static void
__lambda6_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 104 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 104 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 104 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 104 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 104 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 104 "../src/preferences-dialog.vala"
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_TYPE_ADF_FRONT);
#line 397 "preferences-dialog.c"
	}
}


static void
___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 104 "../src/preferences-dialog.vala"
	__lambda6_ (self, _sender);
#line 408 "preferences-dialog.c"
}


static void
__lambda7_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 105 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 105 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 105 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 105 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 105 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 105 "../src/preferences-dialog.vala"
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_TYPE_ADF_BACK);
#line 431 "preferences-dialog.c"
	}
}


static void
___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 105 "../src/preferences-dialog.vala"
	__lambda7_ (self, _sender);
#line 442 "preferences-dialog.c"
}


static void
__lambda8_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 106 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 106 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 106 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 106 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 106 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 106 "../src/preferences-dialog.vala"
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_TYPE_ADF_BOTH);
#line 465 "preferences-dialog.c"
	}
}


static void
___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 106 "../src/preferences-dialog.vala"
	__lambda8_ (self, _sender);
#line 476 "preferences-dialog.c"
}


static void
__lambda9_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
#line 120 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 120 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "brightness", preferences_dialog_get_brightness (self));
#line 488 "preferences-dialog.c"
}


static void
___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                          gpointer self)
{
#line 120 "../src/preferences-dialog.vala"
	__lambda9_ (self);
#line 498 "preferences-dialog.c"
}


static void
__lambda10_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
#line 130 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 130 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "contrast", preferences_dialog_get_contrast (self));
#line 510 "preferences-dialog.c"
}


static void
___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
#line 130 "../src/preferences-dialog.vala"
	__lambda10_ (self);
#line 520 "preferences-dialog.c"
}


static void
__lambda11_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	gint w = 0;
	gint h = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 135 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 138 "../src/preferences-dialog.vala"
	preferences_dialog_get_paper_size (self, &_tmp0_, &_tmp1_);
#line 138 "../src/preferences-dialog.vala"
	w = _tmp0_;
#line 138 "../src/preferences-dialog.vala"
	h = _tmp1_;
#line 139 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "paper-width", w);
#line 140 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "paper-height", h);
#line 544 "preferences-dialog.c"
}


static void
___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
#line 135 "../src/preferences-dialog.vala"
	__lambda11_ (self);
#line 554 "preferences-dialog.c"
}


static void
__lambda12_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 144 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 144 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 144 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 144 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 144 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 144 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 3000);
#line 577 "preferences-dialog.c"
	}
}


static void
___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 144 "../src/preferences-dialog.vala"
	__lambda12_ (self, _sender);
#line 588 "preferences-dialog.c"
}


static void
__lambda13_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 145 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 145 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 145 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 145 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 145 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 145 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 5000);
#line 611 "preferences-dialog.c"
	}
}


static void
___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 145 "../src/preferences-dialog.vala"
	__lambda13_ (self, _sender);
#line 622 "preferences-dialog.c"
}


static void
__lambda14_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 146 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 146 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 146 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 146 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 146 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 146 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 7000);
#line 645 "preferences-dialog.c"
	}
}


static void
___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 146 "../src/preferences-dialog.vala"
	__lambda14_ (self, _sender);
#line 656 "preferences-dialog.c"
}


static void
__lambda15_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 147 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 147 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 147 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 147 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 147 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 147 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 10000);
#line 679 "preferences-dialog.c"
	}
}


static void
___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 147 "../src/preferences-dialog.vala"
	__lambda15_ (self, _sender);
#line 690 "preferences-dialog.c"
}


static void
__lambda16_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 148 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 148 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 148 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 148 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 148 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 148 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 15000);
#line 713 "preferences-dialog.c"
	}
}


static void
___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 148 "../src/preferences-dialog.vala"
	__lambda16_ (self, _sender);
#line 724 "preferences-dialog.c"
}


PreferencesDialog*
preferences_dialog_construct (GType object_type,
                              GSettings* settings)
{
	PreferencesDialog * self = NULL;
	Block7Data* _data7_;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_;
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	GtkListStore* _tmp8_;
	GtkTreeIter _tmp9_;
	GtkListStore* _tmp10_;
	GtkTreeIter _tmp11_ = {0};
	GtkListStore* _tmp12_;
	GtkTreeIter _tmp13_;
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_ = {0};
	GtkListStore* _tmp16_;
	GtkTreeIter _tmp17_;
	GtkListStore* _tmp18_;
	GtkTreeIter _tmp19_ = {0};
	GtkListStore* _tmp20_;
	GtkTreeIter _tmp21_;
	GtkListStore* _tmp22_;
	GtkTreeIter _tmp23_ = {0};
	GtkListStore* _tmp24_;
	GtkTreeIter _tmp25_;
	GtkListStore* _tmp26_;
	GtkTreeIter _tmp27_ = {0};
	GtkListStore* _tmp28_;
	GtkTreeIter _tmp29_;
	GtkListStore* _tmp30_;
	GtkTreeIter _tmp31_ = {0};
	GtkListStore* _tmp32_;
	GtkTreeIter _tmp33_;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp34_;
	GtkComboBox* _tmp35_;
	GtkCellRendererText* _tmp36_;
	GtkComboBox* _tmp37_;
	GtkCellRendererText* _tmp38_;
	gint dpi = 0;
	gint _tmp39_;
	GtkComboBox* _tmp40_;
	gint _tmp41_;
	GtkComboBox* _tmp42_;
	gint _tmp43_;
	GtkComboBox* _tmp44_;
	gint _tmp45_;
	GtkComboBox* _tmp46_;
	GtkRadioButton* _tmp47_;
	GtkRadioButton* _tmp48_;
	GtkRadioButton* _tmp49_;
	GtkCellRendererText* _tmp50_;
	GtkComboBox* _tmp51_;
	GtkCellRendererText* _tmp52_;
	GtkComboBox* _tmp53_;
	GtkCellRendererText* _tmp54_;
	gdouble lower = 0.0;
	GtkAdjustment* _tmp55_;
	gdouble _tmp56_;
	gdouble _tmp57_;
	gchar* darker_label = NULL;
	gchar* _tmp58_;
	gdouble upper = 0.0;
	GtkAdjustment* _tmp59_;
	gdouble _tmp60_;
	gdouble _tmp61_;
	gchar* lighter_label = NULL;
	gchar* _tmp62_;
	GtkScale* _tmp63_;
	gdouble _tmp64_;
	GtkScale* _tmp65_;
	GtkScale* _tmp66_;
	gdouble _tmp67_;
	GtkAdjustment* _tmp68_;
	GtkAdjustment* _tmp69_;
	GtkAdjustment* _tmp70_;
	gdouble _tmp71_;
	gdouble _tmp72_;
	gchar* less_label = NULL;
	gchar* _tmp73_;
	GtkAdjustment* _tmp74_;
	gdouble _tmp75_;
	gdouble _tmp76_;
	gchar* more_label = NULL;
	gchar* _tmp77_;
	GtkScale* _tmp78_;
	gdouble _tmp79_;
	GtkScale* _tmp80_;
	GtkScale* _tmp81_;
	gdouble _tmp82_;
	GtkAdjustment* _tmp83_;
	GtkAdjustment* _tmp84_;
	gint paper_width = 0;
	gint paper_height = 0;
	GtkComboBox* _tmp85_;
	GtkRadioButton* _tmp86_;
	GtkRadioButton* _tmp87_;
	GtkRadioButton* _tmp88_;
	GtkRadioButton* _tmp89_;
	GtkRadioButton* _tmp90_;
#line 62 "../src/preferences-dialog.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 62 "../src/preferences-dialog.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 62 "../src/preferences-dialog.vala"
	_data7_->_ref_count_ = 1;
#line 62 "../src/preferences-dialog.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 62 "../src/preferences-dialog.vala"
	_g_object_unref0 (_data7_->settings);
#line 62 "../src/preferences-dialog.vala"
	_data7_->settings = _tmp0_;
#line 64 "../src/preferences-dialog.vala"
	self = (PreferencesDialog*) g_object_new (object_type, "use-header-bar", 1, NULL);
#line 64 "../src/preferences-dialog.vala"
	_data7_->self = g_object_ref (self);
#line 66 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_data7_->settings);
#line 66 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 66 "../src/preferences-dialog.vala"
	self->priv->settings = _tmp1_;
#line 69 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->paper_size_model;
#line 69 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp2_, &_tmp3_);
#line 69 "../src/preferences-dialog.vala"
	iter = _tmp3_;
#line 70 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->paper_size_model;
#line 70 "../src/preferences-dialog.vala"
	_tmp5_ = iter;
#line 70 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp4_, &_tmp5_, 0, 0, 1, 0, 2, _ ("Automatic"), -1, -1);
#line 73 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->paper_size_model;
#line 73 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp6_, &_tmp7_);
#line 73 "../src/preferences-dialog.vala"
	iter = _tmp7_;
#line 74 "../src/preferences-dialog.vala"
	_tmp8_ = self->priv->paper_size_model;
#line 74 "../src/preferences-dialog.vala"
	_tmp9_ = iter;
#line 74 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp8_, &_tmp9_, 0, 1050, 1, 1480, 2, "A6", -1, -1);
#line 75 "../src/preferences-dialog.vala"
	_tmp10_ = self->priv->paper_size_model;
#line 75 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp10_, &_tmp11_);
#line 75 "../src/preferences-dialog.vala"
	iter = _tmp11_;
#line 76 "../src/preferences-dialog.vala"
	_tmp12_ = self->priv->paper_size_model;
#line 76 "../src/preferences-dialog.vala"
	_tmp13_ = iter;
#line 76 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp12_, &_tmp13_, 0, 1480, 1, 2100, 2, "A5", -1, -1);
#line 77 "../src/preferences-dialog.vala"
	_tmp14_ = self->priv->paper_size_model;
#line 77 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp14_, &_tmp15_);
#line 77 "../src/preferences-dialog.vala"
	iter = _tmp15_;
#line 78 "../src/preferences-dialog.vala"
	_tmp16_ = self->priv->paper_size_model;
#line 78 "../src/preferences-dialog.vala"
	_tmp17_ = iter;
#line 78 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp16_, &_tmp17_, 0, 2100, 1, 2970, 2, "A4", -1, -1);
#line 79 "../src/preferences-dialog.vala"
	_tmp18_ = self->priv->paper_size_model;
#line 79 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp18_, &_tmp19_);
#line 79 "../src/preferences-dialog.vala"
	iter = _tmp19_;
#line 80 "../src/preferences-dialog.vala"
	_tmp20_ = self->priv->paper_size_model;
#line 80 "../src/preferences-dialog.vala"
	_tmp21_ = iter;
#line 80 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp20_, &_tmp21_, 0, 2970, 1, 4200, 2, "A3", -1, -1);
#line 81 "../src/preferences-dialog.vala"
	_tmp22_ = self->priv->paper_size_model;
#line 81 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp22_, &_tmp23_);
#line 81 "../src/preferences-dialog.vala"
	iter = _tmp23_;
#line 82 "../src/preferences-dialog.vala"
	_tmp24_ = self->priv->paper_size_model;
#line 82 "../src/preferences-dialog.vala"
	_tmp25_ = iter;
#line 82 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp24_, &_tmp25_, 0, 2159, 1, 2794, 2, "Letter", -1, -1);
#line 83 "../src/preferences-dialog.vala"
	_tmp26_ = self->priv->paper_size_model;
#line 83 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp26_, &_tmp27_);
#line 83 "../src/preferences-dialog.vala"
	iter = _tmp27_;
#line 84 "../src/preferences-dialog.vala"
	_tmp28_ = self->priv->paper_size_model;
#line 84 "../src/preferences-dialog.vala"
	_tmp29_ = iter;
#line 84 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp28_, &_tmp29_, 0, 2159, 1, 3556, 2, "Legal", -1, -1);
#line 85 "../src/preferences-dialog.vala"
	_tmp30_ = self->priv->paper_size_model;
#line 85 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp30_, &_tmp31_);
#line 85 "../src/preferences-dialog.vala"
	iter = _tmp31_;
#line 86 "../src/preferences-dialog.vala"
	_tmp32_ = self->priv->paper_size_model;
#line 86 "../src/preferences-dialog.vala"
	_tmp33_ = iter;
#line 86 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp32_, &_tmp33_, 0, 1016, 1, 1524, 2, "4×6", -1, -1);
#line 88 "../src/preferences-dialog.vala"
	_tmp34_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 88 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp34_);
#line 88 "../src/preferences-dialog.vala"
	renderer = _tmp34_;
#line 89 "../src/preferences-dialog.vala"
	_tmp35_ = self->priv->device_combo;
#line 89 "../src/preferences-dialog.vala"
	_tmp36_ = renderer;
#line 89 "../src/preferences-dialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp35_, (GtkCellRenderer*) _tmp36_, TRUE);
#line 90 "../src/preferences-dialog.vala"
	_tmp37_ = self->priv->device_combo;
#line 90 "../src/preferences-dialog.vala"
	_tmp38_ = renderer;
#line 90 "../src/preferences-dialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp37_, (GtkCellRenderer*) _tmp38_, "text", 1);
#line 92 "../src/preferences-dialog.vala"
	dpi = g_settings_get_int (_data7_->settings, "text-dpi");
#line 93 "../src/preferences-dialog.vala"
	_tmp39_ = dpi;
#line 93 "../src/preferences-dialog.vala"
	if (_tmp39_ <= 0) {
#line 94 "../src/preferences-dialog.vala"
		dpi = DEFAULT_TEXT_DPI;
#line 980 "preferences-dialog.c"
	}
#line 95 "../src/preferences-dialog.vala"
	_tmp40_ = self->priv->text_dpi_combo;
#line 95 "../src/preferences-dialog.vala"
	_tmp41_ = dpi;
#line 95 "../src/preferences-dialog.vala"
	preferences_dialog_set_dpi_combo (self, _tmp40_, DEFAULT_TEXT_DPI, _tmp41_);
#line 96 "../src/preferences-dialog.vala"
	_tmp42_ = self->priv->text_dpi_combo;
#line 96 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp42_, "changed", (GCallback) ___lambda4__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 97 "../src/preferences-dialog.vala"
	dpi = g_settings_get_int (_data7_->settings, "photo-dpi");
#line 98 "../src/preferences-dialog.vala"
	_tmp43_ = dpi;
#line 98 "../src/preferences-dialog.vala"
	if (_tmp43_ <= 0) {
#line 99 "../src/preferences-dialog.vala"
		dpi = DEFAULT_PHOTO_DPI;
#line 1000 "preferences-dialog.c"
	}
#line 100 "../src/preferences-dialog.vala"
	_tmp44_ = self->priv->photo_dpi_combo;
#line 100 "../src/preferences-dialog.vala"
	_tmp45_ = dpi;
#line 100 "../src/preferences-dialog.vala"
	preferences_dialog_set_dpi_combo (self, _tmp44_, DEFAULT_PHOTO_DPI, _tmp45_);
#line 101 "../src/preferences-dialog.vala"
	_tmp46_ = self->priv->photo_dpi_combo;
#line 101 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp46_, "changed", (GCallback) ___lambda5__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 103 "../src/preferences-dialog.vala"
	preferences_dialog_set_page_side (self, (ScanType) g_settings_get_enum (_data7_->settings, "page-side"));
#line 104 "../src/preferences-dialog.vala"
	_tmp47_ = self->priv->front_side_button;
#line 104 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp47_, "toggled", (GCallback) ___lambda6__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 105 "../src/preferences-dialog.vala"
	_tmp48_ = self->priv->back_side_button;
#line 105 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp48_, "toggled", (GCallback) ___lambda7__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 106 "../src/preferences-dialog.vala"
	_tmp49_ = self->priv->both_side_button;
#line 106 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp49_, "toggled", (GCallback) ___lambda8__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 108 "../src/preferences-dialog.vala"
	_tmp50_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 108 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp50_);
#line 108 "../src/preferences-dialog.vala"
	_g_object_unref0 (renderer);
#line 108 "../src/preferences-dialog.vala"
	renderer = _tmp50_;
#line 109 "../src/preferences-dialog.vala"
	_tmp51_ = self->priv->paper_size_combo;
#line 109 "../src/preferences-dialog.vala"
	_tmp52_ = renderer;
#line 109 "../src/preferences-dialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp51_, (GtkCellRenderer*) _tmp52_, TRUE);
#line 110 "../src/preferences-dialog.vala"
	_tmp53_ = self->priv->paper_size_combo;
#line 110 "../src/preferences-dialog.vala"
	_tmp54_ = renderer;
#line 110 "../src/preferences-dialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp53_, (GtkCellRenderer*) _tmp54_, "text", 2);
#line 112 "../src/preferences-dialog.vala"
	_tmp55_ = self->priv->brightness_adjustment;
#line 112 "../src/preferences-dialog.vala"
	_tmp56_ = gtk_adjustment_get_lower (_tmp55_);
#line 112 "../src/preferences-dialog.vala"
	_tmp57_ = _tmp56_;
#line 112 "../src/preferences-dialog.vala"
	lower = _tmp57_;
#line 113 "../src/preferences-dialog.vala"
	_tmp58_ = g_strdup_printf ("<small>%s</small>", _ ("Darker"));
#line 113 "../src/preferences-dialog.vala"
	darker_label = _tmp58_;
#line 114 "../src/preferences-dialog.vala"
	_tmp59_ = self->priv->brightness_adjustment;
#line 114 "../src/preferences-dialog.vala"
	_tmp60_ = gtk_adjustment_get_upper (_tmp59_);
#line 114 "../src/preferences-dialog.vala"
	_tmp61_ = _tmp60_;
#line 114 "../src/preferences-dialog.vala"
	upper = _tmp61_;
#line 115 "../src/preferences-dialog.vala"
	_tmp62_ = g_strdup_printf ("<small>%s</small>", _ ("Lighter"));
#line 115 "../src/preferences-dialog.vala"
	lighter_label = _tmp62_;
#line 116 "../src/preferences-dialog.vala"
	_tmp63_ = self->priv->brightness_scale;
#line 116 "../src/preferences-dialog.vala"
	_tmp64_ = lower;
#line 116 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp63_, _tmp64_, GTK_POS_BOTTOM, darker_label);
#line 117 "../src/preferences-dialog.vala"
	_tmp65_ = self->priv->brightness_scale;
#line 117 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp65_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
#line 118 "../src/preferences-dialog.vala"
	_tmp66_ = self->priv->brightness_scale;
#line 118 "../src/preferences-dialog.vala"
	_tmp67_ = upper;
#line 118 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp66_, _tmp67_, GTK_POS_BOTTOM, lighter_label);
#line 119 "../src/preferences-dialog.vala"
	_tmp68_ = self->priv->brightness_adjustment;
#line 119 "../src/preferences-dialog.vala"
	gtk_adjustment_set_value (_tmp68_, (gdouble) g_settings_get_int (_data7_->settings, "brightness"));
#line 120 "../src/preferences-dialog.vala"
	_tmp69_ = self->priv->brightness_adjustment;
#line 120 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp69_, "value-changed", (GCallback) ___lambda9__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 122 "../src/preferences-dialog.vala"
	_tmp70_ = self->priv->contrast_adjustment;
#line 122 "../src/preferences-dialog.vala"
	_tmp71_ = gtk_adjustment_get_lower (_tmp70_);
#line 122 "../src/preferences-dialog.vala"
	_tmp72_ = _tmp71_;
#line 122 "../src/preferences-dialog.vala"
	lower = _tmp72_;
#line 123 "../src/preferences-dialog.vala"
	_tmp73_ = g_strdup_printf ("<small>%s</small>", _ ("Less"));
#line 123 "../src/preferences-dialog.vala"
	less_label = _tmp73_;
#line 124 "../src/preferences-dialog.vala"
	_tmp74_ = self->priv->contrast_adjustment;
#line 124 "../src/preferences-dialog.vala"
	_tmp75_ = gtk_adjustment_get_upper (_tmp74_);
#line 124 "../src/preferences-dialog.vala"
	_tmp76_ = _tmp75_;
#line 124 "../src/preferences-dialog.vala"
	upper = _tmp76_;
#line 125 "../src/preferences-dialog.vala"
	_tmp77_ = g_strdup_printf ("<small>%s</small>", _ ("More"));
#line 125 "../src/preferences-dialog.vala"
	more_label = _tmp77_;
#line 126 "../src/preferences-dialog.vala"
	_tmp78_ = self->priv->contrast_scale;
#line 126 "../src/preferences-dialog.vala"
	_tmp79_ = lower;
#line 126 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp78_, _tmp79_, GTK_POS_BOTTOM, less_label);
#line 127 "../src/preferences-dialog.vala"
	_tmp80_ = self->priv->contrast_scale;
#line 127 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp80_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
#line 128 "../src/preferences-dialog.vala"
	_tmp81_ = self->priv->contrast_scale;
#line 128 "../src/preferences-dialog.vala"
	_tmp82_ = upper;
#line 128 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp81_, _tmp82_, GTK_POS_BOTTOM, more_label);
#line 129 "../src/preferences-dialog.vala"
	_tmp83_ = self->priv->contrast_adjustment;
#line 129 "../src/preferences-dialog.vala"
	gtk_adjustment_set_value (_tmp83_, (gdouble) g_settings_get_int (_data7_->settings, "contrast"));
#line 130 "../src/preferences-dialog.vala"
	_tmp84_ = self->priv->contrast_adjustment;
#line 130 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp84_, "value-changed", (GCallback) ___lambda10__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 132 "../src/preferences-dialog.vala"
	paper_width = g_settings_get_int (_data7_->settings, "paper-width");
#line 133 "../src/preferences-dialog.vala"
	paper_height = g_settings_get_int (_data7_->settings, "paper-height");
#line 134 "../src/preferences-dialog.vala"
	preferences_dialog_set_paper_size (self, paper_width, paper_height);
#line 135 "../src/preferences-dialog.vala"
	_tmp85_ = self->priv->paper_size_combo;
#line 135 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp85_, "changed", (GCallback) ___lambda11__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 143 "../src/preferences-dialog.vala"
	preferences_dialog_set_page_delay (self, g_settings_get_int (_data7_->settings, "page-delay"));
#line 144 "../src/preferences-dialog.vala"
	_tmp86_ = self->priv->page_delay_3s_button;
#line 144 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp86_, "toggled", (GCallback) ___lambda12__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 145 "../src/preferences-dialog.vala"
	_tmp87_ = self->priv->page_delay_5s_button;
#line 145 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp87_, "toggled", (GCallback) ___lambda13__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 146 "../src/preferences-dialog.vala"
	_tmp88_ = self->priv->page_delay_7s_button;
#line 146 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp88_, "toggled", (GCallback) ___lambda14__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 147 "../src/preferences-dialog.vala"
	_tmp89_ = self->priv->page_delay_10s_button;
#line 147 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp89_, "toggled", (GCallback) ___lambda15__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 148 "../src/preferences-dialog.vala"
	_tmp90_ = self->priv->page_delay_15s_button;
#line 148 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp90_, "toggled", (GCallback) ___lambda16__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 62 "../src/preferences-dialog.vala"
	_g_free0 (more_label);
#line 62 "../src/preferences-dialog.vala"
	_g_free0 (less_label);
#line 62 "../src/preferences-dialog.vala"
	_g_free0 (lighter_label);
#line 62 "../src/preferences-dialog.vala"
	_g_free0 (darker_label);
#line 62 "../src/preferences-dialog.vala"
	_g_object_unref0 (renderer);
#line 62 "../src/preferences-dialog.vala"
	block7_data_unref (_data7_);
#line 62 "../src/preferences-dialog.vala"
	_data7_ = NULL;
#line 62 "../src/preferences-dialog.vala"
	return self;
#line 1190 "preferences-dialog.c"
}


PreferencesDialog*
preferences_dialog_new (GSettings* settings)
{
#line 62 "../src/preferences-dialog.vala"
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, settings);
#line 1199 "preferences-dialog.c"
}


void
preferences_dialog_set_scan_devices (PreferencesDialog* self,
                                     GList* devices)
{
	gboolean have_selection = FALSE;
	gboolean _tmp0_;
	gint index = 0;
	GtkTreeIter iter = {0};
	gboolean _tmp49_;
#line 151 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/preferences-dialog.vala"
	self->priv->setting_devices = TRUE;
#line 156 "../src/preferences-dialog.vala"
	have_selection = FALSE;
#line 157 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->user_selected_device;
#line 157 "../src/preferences-dialog.vala"
	if (_tmp0_) {
#line 1222 "preferences-dialog.c"
		GtkComboBox* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 158 "../src/preferences-dialog.vala"
		_tmp1_ = self->priv->device_combo;
#line 158 "../src/preferences-dialog.vala"
		_tmp2_ = gtk_combo_box_get_active (_tmp1_);
#line 158 "../src/preferences-dialog.vala"
		_tmp3_ = _tmp2_;
#line 158 "../src/preferences-dialog.vala"
		have_selection = _tmp3_ >= 0;
#line 1234 "preferences-dialog.c"
	}
#line 161 "../src/preferences-dialog.vala"
	index = 0;
#line 1238 "preferences-dialog.c"
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
#line 163 "../src/preferences-dialog.vala"
		device_collection = devices;
#line 163 "../src/preferences-dialog.vala"
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 1246 "preferences-dialog.c"
			ScanDevice* _tmp4_;
			ScanDevice* device = NULL;
#line 163 "../src/preferences-dialog.vala"
			_tmp4_ = _g_object_ref0 ((ScanDevice*) device_it->data);
#line 163 "../src/preferences-dialog.vala"
			device = _tmp4_;
#line 1253 "preferences-dialog.c"
			{
				gint n_delete = 0;
				GtkListStore* _tmp5_;
				gint _tmp6_;
				GtkTreeIter _tmp7_ = {0};
				gboolean _tmp8_;
				gint _tmp21_;
				gint _tmp43_;
#line 165 "../src/preferences-dialog.vala"
				n_delete = -1;
#line 168 "../src/preferences-dialog.vala"
				_tmp5_ = self->priv->device_model;
#line 168 "../src/preferences-dialog.vala"
				_tmp6_ = index;
#line 168 "../src/preferences-dialog.vala"
				_tmp8_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp5_, &_tmp7_, NULL, _tmp6_);
#line 168 "../src/preferences-dialog.vala"
				iter = _tmp7_;
#line 168 "../src/preferences-dialog.vala"
				if (_tmp8_) {
#line 1274 "preferences-dialog.c"
					gint i = 0;
#line 170 "../src/preferences-dialog.vala"
					i = 0;
#line 1278 "preferences-dialog.c"
					{
						gboolean _tmp9_ = FALSE;
#line 171 "../src/preferences-dialog.vala"
						_tmp9_ = TRUE;
#line 171 "../src/preferences-dialog.vala"
						while (TRUE) {
#line 1285 "preferences-dialog.c"
							gchar* name = NULL;
							gboolean matched = FALSE;
							GtkListStore* _tmp12_;
							GtkTreeIter _tmp13_;
							gchar* _tmp14_ = NULL;
							const gchar* _tmp15_;
							ScanDevice* _tmp16_;
							const gchar* _tmp17_;
							gboolean _tmp18_;
							gint _tmp20_;
#line 171 "../src/preferences-dialog.vala"
							if (!_tmp9_) {
#line 1298 "preferences-dialog.c"
								GtkListStore* _tmp10_;
								gboolean _tmp11_;
#line 185 "../src/preferences-dialog.vala"
								_tmp10_ = self->priv->device_model;
#line 185 "../src/preferences-dialog.vala"
								_tmp11_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp10_, &iter);
#line 185 "../src/preferences-dialog.vala"
								if (!_tmp11_) {
#line 185 "../src/preferences-dialog.vala"
									break;
#line 1309 "preferences-dialog.c"
								}
							}
#line 171 "../src/preferences-dialog.vala"
							_tmp9_ = FALSE;
#line 176 "../src/preferences-dialog.vala"
							_tmp12_ = self->priv->device_model;
#line 176 "../src/preferences-dialog.vala"
							_tmp13_ = iter;
#line 176 "../src/preferences-dialog.vala"
							gtk_tree_model_get ((GtkTreeModel*) _tmp12_, &_tmp13_, 0, &_tmp14_, -1, -1);
#line 176 "../src/preferences-dialog.vala"
							_g_free0 (name);
#line 176 "../src/preferences-dialog.vala"
							name = _tmp14_;
#line 177 "../src/preferences-dialog.vala"
							_tmp15_ = name;
#line 177 "../src/preferences-dialog.vala"
							_tmp16_ = device;
#line 177 "../src/preferences-dialog.vala"
							_tmp17_ = _tmp16_->name;
#line 177 "../src/preferences-dialog.vala"
							matched = g_strcmp0 (_tmp15_, _tmp17_) == 0;
#line 179 "../src/preferences-dialog.vala"
							_tmp18_ = matched;
#line 179 "../src/preferences-dialog.vala"
							if (_tmp18_) {
#line 1336 "preferences-dialog.c"
								gint _tmp19_;
#line 181 "../src/preferences-dialog.vala"
								_tmp19_ = i;
#line 181 "../src/preferences-dialog.vala"
								n_delete = _tmp19_;
#line 182 "../src/preferences-dialog.vala"
								_g_free0 (name);
#line 182 "../src/preferences-dialog.vala"
								break;
#line 1346 "preferences-dialog.c"
							}
#line 184 "../src/preferences-dialog.vala"
							_tmp20_ = i;
#line 184 "../src/preferences-dialog.vala"
							i = _tmp20_ + 1;
#line 171 "../src/preferences-dialog.vala"
							_g_free0 (name);
#line 1354 "preferences-dialog.c"
						}
					}
				}
#line 189 "../src/preferences-dialog.vala"
				_tmp21_ = n_delete;
#line 189 "../src/preferences-dialog.vala"
				if (_tmp21_ >= 0) {
#line 1362 "preferences-dialog.c"
					gint i = 0;
					GtkListStore* _tmp22_;
					GtkTreeIter _tmp23_;
					ScanDevice* _tmp24_;
					const gchar* _tmp25_;
#line 194 "../src/preferences-dialog.vala"
					_tmp22_ = self->priv->device_model;
#line 194 "../src/preferences-dialog.vala"
					_tmp23_ = iter;
#line 194 "../src/preferences-dialog.vala"
					_tmp24_ = device;
#line 194 "../src/preferences-dialog.vala"
					_tmp25_ = _tmp24_->label;
#line 194 "../src/preferences-dialog.vala"
					gtk_list_store_set (_tmp22_, &_tmp23_, 1, _tmp25_, -1, -1);
#line 1378 "preferences-dialog.c"
					{
						gboolean _tmp26_ = FALSE;
#line 196 "../src/preferences-dialog.vala"
						i = 0;
#line 196 "../src/preferences-dialog.vala"
						_tmp26_ = TRUE;
#line 196 "../src/preferences-dialog.vala"
						while (TRUE) {
#line 1387 "preferences-dialog.c"
							gint _tmp28_;
							gint _tmp29_;
							GtkListStore* _tmp30_;
							gint _tmp31_;
							GtkTreeIter _tmp32_ = {0};
							GtkListStore* _tmp33_;
#line 196 "../src/preferences-dialog.vala"
							if (!_tmp26_) {
#line 1396 "preferences-dialog.c"
								gint _tmp27_;
#line 196 "../src/preferences-dialog.vala"
								_tmp27_ = i;
#line 196 "../src/preferences-dialog.vala"
								i = _tmp27_ + 1;
#line 1402 "preferences-dialog.c"
							}
#line 196 "../src/preferences-dialog.vala"
							_tmp26_ = FALSE;
#line 196 "../src/preferences-dialog.vala"
							_tmp28_ = i;
#line 196 "../src/preferences-dialog.vala"
							_tmp29_ = n_delete;
#line 196 "../src/preferences-dialog.vala"
							if (!(_tmp28_ < _tmp29_)) {
#line 196 "../src/preferences-dialog.vala"
								break;
#line 1414 "preferences-dialog.c"
							}
#line 198 "../src/preferences-dialog.vala"
							_tmp30_ = self->priv->device_model;
#line 198 "../src/preferences-dialog.vala"
							_tmp31_ = index;
#line 198 "../src/preferences-dialog.vala"
							gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp30_, &_tmp32_, NULL, _tmp31_);
#line 198 "../src/preferences-dialog.vala"
							iter = _tmp32_;
#line 200 "../src/preferences-dialog.vala"
							_tmp33_ = self->priv->device_model;
#line 200 "../src/preferences-dialog.vala"
							gtk_list_store_remove (_tmp33_, &iter);
#line 1428 "preferences-dialog.c"
						}
					}
				} else {
					GtkListStore* _tmp34_;
					gint _tmp35_;
					GtkTreeIter _tmp36_ = {0};
					GtkListStore* _tmp37_;
					GtkTreeIter _tmp38_;
					ScanDevice* _tmp39_;
					const gchar* _tmp40_;
					ScanDevice* _tmp41_;
					const gchar* _tmp42_;
#line 208 "../src/preferences-dialog.vala"
					_tmp34_ = self->priv->device_model;
#line 208 "../src/preferences-dialog.vala"
					_tmp35_ = index;
#line 208 "../src/preferences-dialog.vala"
					gtk_list_store_insert (_tmp34_, &_tmp36_, _tmp35_);
#line 208 "../src/preferences-dialog.vala"
					iter = _tmp36_;
#line 209 "../src/preferences-dialog.vala"
					_tmp37_ = self->priv->device_model;
#line 209 "../src/preferences-dialog.vala"
					_tmp38_ = iter;
#line 209 "../src/preferences-dialog.vala"
					_tmp39_ = device;
#line 209 "../src/preferences-dialog.vala"
					_tmp40_ = _tmp39_->name;
#line 209 "../src/preferences-dialog.vala"
					_tmp41_ = device;
#line 209 "../src/preferences-dialog.vala"
					_tmp42_ = _tmp41_->label;
#line 209 "../src/preferences-dialog.vala"
					gtk_list_store_set (_tmp37_, &_tmp38_, 0, _tmp40_, 1, _tmp42_, -1, -1);
#line 1463 "preferences-dialog.c"
				}
#line 211 "../src/preferences-dialog.vala"
				_tmp43_ = index;
#line 211 "../src/preferences-dialog.vala"
				index = _tmp43_ + 1;
#line 163 "../src/preferences-dialog.vala"
				_g_object_unref0 (device);
#line 1471 "preferences-dialog.c"
			}
		}
	}
#line 215 "../src/preferences-dialog.vala"
	while (TRUE) {
#line 1477 "preferences-dialog.c"
		GtkListStore* _tmp44_;
		gint _tmp45_;
		GtkTreeIter _tmp46_ = {0};
		gboolean _tmp47_;
		GtkListStore* _tmp48_;
#line 215 "../src/preferences-dialog.vala"
		_tmp44_ = self->priv->device_model;
#line 215 "../src/preferences-dialog.vala"
		_tmp45_ = index;
#line 215 "../src/preferences-dialog.vala"
		_tmp47_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp44_, &_tmp46_, NULL, _tmp45_);
#line 215 "../src/preferences-dialog.vala"
		iter = _tmp46_;
#line 215 "../src/preferences-dialog.vala"
		if (!_tmp47_) {
#line 215 "../src/preferences-dialog.vala"
			break;
#line 1495 "preferences-dialog.c"
		}
#line 217 "../src/preferences-dialog.vala"
		_tmp48_ = self->priv->device_model;
#line 217 "../src/preferences-dialog.vala"
		gtk_list_store_remove (_tmp48_, &iter);
#line 1501 "preferences-dialog.c"
	}
#line 223 "../src/preferences-dialog.vala"
	_tmp49_ = have_selection;
#line 223 "../src/preferences-dialog.vala"
	if (!_tmp49_) {
#line 1507 "preferences-dialog.c"
		gchar* device = NULL;
		GSettings* _tmp50_;
		gchar* _tmp51_;
		gboolean _tmp52_ = FALSE;
		const gchar* _tmp53_;
#line 225 "../src/preferences-dialog.vala"
		_tmp50_ = self->priv->settings;
#line 225 "../src/preferences-dialog.vala"
		_tmp51_ = g_settings_get_string (_tmp50_, "selected-device");
#line 225 "../src/preferences-dialog.vala"
		device = _tmp51_;
#line 226 "../src/preferences-dialog.vala"
		_tmp53_ = device;
#line 226 "../src/preferences-dialog.vala"
		if (_tmp53_ != NULL) {
#line 1523 "preferences-dialog.c"
			const gchar* _tmp54_;
			GtkTreeIter _tmp55_ = {0};
			gboolean _tmp56_;
#line 226 "../src/preferences-dialog.vala"
			_tmp54_ = device;
#line 226 "../src/preferences-dialog.vala"
			_tmp56_ = preferences_dialog_find_scan_device (self, _tmp54_, &_tmp55_);
#line 226 "../src/preferences-dialog.vala"
			iter = _tmp55_;
#line 226 "../src/preferences-dialog.vala"
			_tmp52_ = _tmp56_;
#line 1535 "preferences-dialog.c"
		} else {
#line 226 "../src/preferences-dialog.vala"
			_tmp52_ = FALSE;
#line 1539 "preferences-dialog.c"
		}
#line 226 "../src/preferences-dialog.vala"
		if (_tmp52_) {
#line 1543 "preferences-dialog.c"
			GtkComboBox* _tmp57_;
			GtkTreeIter _tmp58_;
#line 227 "../src/preferences-dialog.vala"
			_tmp57_ = self->priv->device_combo;
#line 227 "../src/preferences-dialog.vala"
			_tmp58_ = iter;
#line 227 "../src/preferences-dialog.vala"
			gtk_combo_box_set_active_iter (_tmp57_, &_tmp58_);
#line 1552 "preferences-dialog.c"
		} else {
			GtkComboBox* _tmp59_;
#line 229 "../src/preferences-dialog.vala"
			_tmp59_ = self->priv->device_combo;
#line 229 "../src/preferences-dialog.vala"
			gtk_combo_box_set_active (_tmp59_, 0);
#line 1559 "preferences-dialog.c"
		}
#line 223 "../src/preferences-dialog.vala"
		_g_free0 (device);
#line 1563 "preferences-dialog.c"
	}
#line 232 "../src/preferences-dialog.vala"
	self->priv->setting_devices = FALSE;
#line 1567 "preferences-dialog.c"
}


gchar*
preferences_dialog_get_selected_device (PreferencesDialog* self)
{
	gchar* result = NULL;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
#line 235 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 239 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->device_combo;
#line 239 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 239 "../src/preferences-dialog.vala"
	iter = _tmp1_;
#line 239 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 1589 "preferences-dialog.c"
		gchar* device = NULL;
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gchar* _tmp5_ = NULL;
#line 242 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->device_model;
#line 242 "../src/preferences-dialog.vala"
		_tmp4_ = iter;
#line 242 "../src/preferences-dialog.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_tmp5_, -1, -1);
#line 242 "../src/preferences-dialog.vala"
		_g_free0 (device);
#line 242 "../src/preferences-dialog.vala"
		device = _tmp5_;
#line 243 "../src/preferences-dialog.vala"
		result = device;
#line 243 "../src/preferences-dialog.vala"
		return result;
#line 1608 "preferences-dialog.c"
	}
#line 246 "../src/preferences-dialog.vala"
	result = NULL;
#line 246 "../src/preferences-dialog.vala"
	return result;
#line 1614 "preferences-dialog.c"
}


gchar*
preferences_dialog_get_selected_device_label (PreferencesDialog* self)
{
	gchar* result = NULL;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
#line 249 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 253 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->device_combo;
#line 253 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 253 "../src/preferences-dialog.vala"
	iter = _tmp1_;
#line 253 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 1636 "preferences-dialog.c"
		gchar* label = NULL;
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gchar* _tmp5_ = NULL;
#line 256 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->device_model;
#line 256 "../src/preferences-dialog.vala"
		_tmp4_ = iter;
#line 256 "../src/preferences-dialog.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 1, &_tmp5_, -1, -1);
#line 256 "../src/preferences-dialog.vala"
		_g_free0 (label);
#line 256 "../src/preferences-dialog.vala"
		label = _tmp5_;
#line 257 "../src/preferences-dialog.vala"
		result = label;
#line 257 "../src/preferences-dialog.vala"
		return result;
#line 1655 "preferences-dialog.c"
	}
#line 260 "../src/preferences-dialog.vala"
	result = NULL;
#line 260 "../src/preferences-dialog.vala"
	return result;
#line 1661 "preferences-dialog.c"
}


void
preferences_dialog_set_selected_device (PreferencesDialog* self,
                                        const gchar* device)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	GtkComboBox* _tmp2_;
	GtkTreeIter _tmp3_;
#line 263 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/preferences-dialog.vala"
	g_return_if_fail (device != NULL);
#line 265 "../src/preferences-dialog.vala"
	self->priv->user_selected_device = TRUE;
#line 268 "../src/preferences-dialog.vala"
	_tmp1_ = preferences_dialog_find_scan_device (self, device, &_tmp0_);
#line 268 "../src/preferences-dialog.vala"
	iter = _tmp0_;
#line 268 "../src/preferences-dialog.vala"
	if (!_tmp1_) {
#line 269 "../src/preferences-dialog.vala"
		return;
#line 1688 "preferences-dialog.c"
	}
#line 271 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->device_combo;
#line 271 "../src/preferences-dialog.vala"
	_tmp3_ = iter;
#line 271 "../src/preferences-dialog.vala"
	gtk_combo_box_set_active_iter (_tmp2_, &_tmp3_);
#line 1696 "preferences-dialog.c"
}


static gboolean
preferences_dialog_find_scan_device (PreferencesDialog* self,
                                     const gchar* device,
                                     GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gboolean have_iter = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
#line 274 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 274 "../src/preferences-dialog.vala"
	g_return_val_if_fail (device != NULL, FALSE);
#line 276 "../src/preferences-dialog.vala"
	have_iter = FALSE;
#line 278 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->device_model;
#line 278 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
#line 278 "../src/preferences-dialog.vala"
	_vala_iter = _tmp1_;
#line 278 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 1725 "preferences-dialog.c"
		{
			gboolean _tmp3_ = FALSE;
#line 280 "../src/preferences-dialog.vala"
			_tmp3_ = TRUE;
#line 280 "../src/preferences-dialog.vala"
			while (TRUE) {
#line 1732 "preferences-dialog.c"
				gchar* d = NULL;
				GtkListStore* _tmp8_;
				GtkTreeIter _tmp9_;
				gchar* _tmp10_ = NULL;
				const gchar* _tmp11_;
#line 280 "../src/preferences-dialog.vala"
				if (!_tmp3_) {
#line 1740 "preferences-dialog.c"
					gboolean _tmp4_ = FALSE;
					gboolean _tmp5_;
#line 286 "../src/preferences-dialog.vala"
					_tmp5_ = have_iter;
#line 286 "../src/preferences-dialog.vala"
					if (!_tmp5_) {
#line 1747 "preferences-dialog.c"
						GtkListStore* _tmp6_;
						gboolean _tmp7_;
#line 286 "../src/preferences-dialog.vala"
						_tmp6_ = self->priv->device_model;
#line 286 "../src/preferences-dialog.vala"
						_tmp7_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp6_, &_vala_iter);
#line 286 "../src/preferences-dialog.vala"
						_tmp4_ = _tmp7_;
#line 1756 "preferences-dialog.c"
					} else {
#line 286 "../src/preferences-dialog.vala"
						_tmp4_ = FALSE;
#line 1760 "preferences-dialog.c"
					}
#line 286 "../src/preferences-dialog.vala"
					if (!_tmp4_) {
#line 286 "../src/preferences-dialog.vala"
						break;
#line 1766 "preferences-dialog.c"
					}
				}
#line 280 "../src/preferences-dialog.vala"
				_tmp3_ = FALSE;
#line 283 "../src/preferences-dialog.vala"
				_tmp8_ = self->priv->device_model;
#line 283 "../src/preferences-dialog.vala"
				_tmp9_ = _vala_iter;
#line 283 "../src/preferences-dialog.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp8_, &_tmp9_, 0, &_tmp10_, -1, -1);
#line 283 "../src/preferences-dialog.vala"
				_g_free0 (d);
#line 283 "../src/preferences-dialog.vala"
				d = _tmp10_;
#line 284 "../src/preferences-dialog.vala"
				_tmp11_ = d;
#line 284 "../src/preferences-dialog.vala"
				if (g_strcmp0 (_tmp11_, device) == 0) {
#line 285 "../src/preferences-dialog.vala"
					have_iter = TRUE;
#line 1787 "preferences-dialog.c"
				}
#line 280 "../src/preferences-dialog.vala"
				_g_free0 (d);
#line 1791 "preferences-dialog.c"
			}
		}
	}
#line 289 "../src/preferences-dialog.vala"
	result = have_iter;
#line 289 "../src/preferences-dialog.vala"
	if (iter) {
#line 289 "../src/preferences-dialog.vala"
		*iter = _vala_iter;
#line 1801 "preferences-dialog.c"
	}
#line 289 "../src/preferences-dialog.vala"
	return result;
#line 1805 "preferences-dialog.c"
}


static void
preferences_dialog_set_page_side (PreferencesDialog* self,
                                  ScanType page_side)
{
#line 292 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 294 "../src/preferences-dialog.vala"
	switch (page_side) {
#line 294 "../src/preferences-dialog.vala"
		case SCAN_TYPE_ADF_FRONT:
#line 1819 "preferences-dialog.c"
		{
			GtkRadioButton* _tmp0_;
#line 297 "../src/preferences-dialog.vala"
			_tmp0_ = self->priv->front_side_button;
#line 297 "../src/preferences-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
#line 298 "../src/preferences-dialog.vala"
			break;
#line 1828 "preferences-dialog.c"
		}
#line 294 "../src/preferences-dialog.vala"
		case SCAN_TYPE_ADF_BACK:
#line 1832 "preferences-dialog.c"
		{
			GtkRadioButton* _tmp1_;
#line 300 "../src/preferences-dialog.vala"
			_tmp1_ = self->priv->back_side_button;
#line 300 "../src/preferences-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
#line 301 "../src/preferences-dialog.vala"
			break;
#line 1841 "preferences-dialog.c"
		}
		default:
#line 294 "../src/preferences-dialog.vala"
		case SCAN_TYPE_ADF_BOTH:
#line 1846 "preferences-dialog.c"
		{
			GtkRadioButton* _tmp2_;
#line 304 "../src/preferences-dialog.vala"
			_tmp2_ = self->priv->both_side_button;
#line 304 "../src/preferences-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
#line 305 "../src/preferences-dialog.vala"
			break;
#line 1855 "preferences-dialog.c"
		}
	}
}


ScanType
preferences_dialog_get_page_side (PreferencesDialog* self)
{
	ScanType result = 0;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 309 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 311 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->front_side_button;
#line 311 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 311 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 311 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 312 "../src/preferences-dialog.vala"
		result = SCAN_TYPE_ADF_FRONT;
#line 312 "../src/preferences-dialog.vala"
		return result;
#line 1882 "preferences-dialog.c"
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 313 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->back_side_button;
#line 313 "../src/preferences-dialog.vala"
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
#line 313 "../src/preferences-dialog.vala"
		_tmp5_ = _tmp4_;
#line 313 "../src/preferences-dialog.vala"
		if (_tmp5_) {
#line 314 "../src/preferences-dialog.vala"
			result = SCAN_TYPE_ADF_BACK;
#line 314 "../src/preferences-dialog.vala"
			return result;
#line 1899 "preferences-dialog.c"
		} else {
#line 316 "../src/preferences-dialog.vala"
			result = SCAN_TYPE_ADF_BOTH;
#line 316 "../src/preferences-dialog.vala"
			return result;
#line 1905 "preferences-dialog.c"
		}
	}
}


void
preferences_dialog_set_paper_size (PreferencesDialog* self,
                                   gint width,
                                   gint height)
{
	GtkTreeIter iter = {0};
	gboolean have_iter = FALSE;
	gboolean _tmp14_;
	gboolean _tmp18_;
#line 319 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 1922 "preferences-dialog.c"
	{
		GtkListStore* _tmp0_;
		GtkTreeIter _tmp1_ = {0};
		gboolean _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 324 "../src/preferences-dialog.vala"
		_tmp0_ = self->priv->paper_size_model;
#line 324 "../src/preferences-dialog.vala"
		_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
#line 324 "../src/preferences-dialog.vala"
		iter = _tmp1_;
#line 324 "../src/preferences-dialog.vala"
		have_iter = _tmp2_;
#line 324 "../src/preferences-dialog.vala"
		_tmp3_ = TRUE;
#line 324 "../src/preferences-dialog.vala"
		while (TRUE) {
#line 1940 "preferences-dialog.c"
			gboolean _tmp6_;
			gint w = 0;
			gint h = 0;
			GtkListStore* _tmp7_;
			GtkTreeIter _tmp8_;
			gint _tmp9_ = 0;
			gint _tmp10_ = 0;
			gboolean _tmp11_ = FALSE;
			gint _tmp12_;
#line 324 "../src/preferences-dialog.vala"
			if (!_tmp3_) {
#line 1952 "preferences-dialog.c"
				GtkListStore* _tmp4_;
				gboolean _tmp5_;
#line 326 "../src/preferences-dialog.vala"
				_tmp4_ = self->priv->paper_size_model;
#line 326 "../src/preferences-dialog.vala"
				_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp4_, &iter);
#line 326 "../src/preferences-dialog.vala"
				have_iter = _tmp5_;
#line 1961 "preferences-dialog.c"
			}
#line 324 "../src/preferences-dialog.vala"
			_tmp3_ = FALSE;
#line 325 "../src/preferences-dialog.vala"
			_tmp6_ = have_iter;
#line 325 "../src/preferences-dialog.vala"
			if (!_tmp6_) {
#line 325 "../src/preferences-dialog.vala"
				break;
#line 1971 "preferences-dialog.c"
			}
#line 329 "../src/preferences-dialog.vala"
			_tmp7_ = self->priv->paper_size_model;
#line 329 "../src/preferences-dialog.vala"
			_tmp8_ = iter;
#line 329 "../src/preferences-dialog.vala"
			gtk_tree_model_get ((GtkTreeModel*) _tmp7_, &_tmp8_, 0, &_tmp9_, 1, &_tmp10_, -1, -1);
#line 329 "../src/preferences-dialog.vala"
			w = _tmp9_;
#line 329 "../src/preferences-dialog.vala"
			h = _tmp10_;
#line 330 "../src/preferences-dialog.vala"
			_tmp12_ = w;
#line 330 "../src/preferences-dialog.vala"
			if (_tmp12_ == width) {
#line 1987 "preferences-dialog.c"
				gint _tmp13_;
#line 330 "../src/preferences-dialog.vala"
				_tmp13_ = h;
#line 330 "../src/preferences-dialog.vala"
				_tmp11_ = _tmp13_ == height;
#line 1993 "preferences-dialog.c"
			} else {
#line 330 "../src/preferences-dialog.vala"
				_tmp11_ = FALSE;
#line 1997 "preferences-dialog.c"
			}
#line 330 "../src/preferences-dialog.vala"
			if (_tmp11_) {
#line 331 "../src/preferences-dialog.vala"
				break;
#line 2003 "preferences-dialog.c"
			}
		}
	}
#line 334 "../src/preferences-dialog.vala"
	_tmp14_ = have_iter;
#line 334 "../src/preferences-dialog.vala"
	if (!_tmp14_) {
#line 2011 "preferences-dialog.c"
		GtkListStore* _tmp15_;
		GtkTreeIter _tmp16_ = {0};
		gboolean _tmp17_;
#line 335 "../src/preferences-dialog.vala"
		_tmp15_ = self->priv->paper_size_model;
#line 335 "../src/preferences-dialog.vala"
		_tmp17_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp15_, &_tmp16_);
#line 335 "../src/preferences-dialog.vala"
		iter = _tmp16_;
#line 335 "../src/preferences-dialog.vala"
		have_iter = _tmp17_;
#line 2023 "preferences-dialog.c"
	}
#line 336 "../src/preferences-dialog.vala"
	_tmp18_ = have_iter;
#line 336 "../src/preferences-dialog.vala"
	if (_tmp18_) {
#line 2029 "preferences-dialog.c"
		GtkComboBox* _tmp19_;
		GtkTreeIter _tmp20_;
#line 337 "../src/preferences-dialog.vala"
		_tmp19_ = self->priv->paper_size_combo;
#line 337 "../src/preferences-dialog.vala"
		_tmp20_ = iter;
#line 337 "../src/preferences-dialog.vala"
		gtk_combo_box_set_active_iter (_tmp19_, &_tmp20_);
#line 2038 "preferences-dialog.c"
	}
}


gint
preferences_dialog_get_text_dpi (PreferencesDialog* self)
{
	gint result = 0;
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
#line 340 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 343 "../src/preferences-dialog.vala"
	dpi = DEFAULT_TEXT_DPI;
#line 345 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->text_dpi_combo;
#line 345 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 345 "../src/preferences-dialog.vala"
	iter = _tmp1_;
#line 345 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 2064 "preferences-dialog.c"
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gint _tmp5_ = 0;
#line 346 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->text_dpi_model;
#line 346 "../src/preferences-dialog.vala"
		_tmp4_ = iter;
#line 346 "../src/preferences-dialog.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_tmp5_, -1, -1);
#line 346 "../src/preferences-dialog.vala"
		dpi = _tmp5_;
#line 2076 "preferences-dialog.c"
	}
#line 348 "../src/preferences-dialog.vala"
	result = dpi;
#line 348 "../src/preferences-dialog.vala"
	return result;
#line 2082 "preferences-dialog.c"
}


gint
preferences_dialog_get_photo_dpi (PreferencesDialog* self)
{
	gint result = 0;
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
#line 351 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 354 "../src/preferences-dialog.vala"
	dpi = DEFAULT_PHOTO_DPI;
#line 356 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->photo_dpi_combo;
#line 356 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 356 "../src/preferences-dialog.vala"
	iter = _tmp1_;
#line 356 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 2107 "preferences-dialog.c"
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gint _tmp5_ = 0;
#line 357 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->photo_dpi_model;
#line 357 "../src/preferences-dialog.vala"
		_tmp4_ = iter;
#line 357 "../src/preferences-dialog.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_tmp5_, -1, -1);
#line 357 "../src/preferences-dialog.vala"
		dpi = _tmp5_;
#line 2119 "preferences-dialog.c"
	}
#line 359 "../src/preferences-dialog.vala"
	result = dpi;
#line 359 "../src/preferences-dialog.vala"
	return result;
#line 2125 "preferences-dialog.c"
}


gboolean
preferences_dialog_get_paper_size (PreferencesDialog* self,
                                   gint* width,
                                   gint* height)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	gboolean result = FALSE;
	GtkTreeIter iter = {0};
	gint _tmp0_;
	GtkComboBox* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
#line 362 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 366 "../src/preferences-dialog.vala"
	_vala_height = 0;
#line 366 "../src/preferences-dialog.vala"
	_tmp0_ = _vala_height;
#line 366 "../src/preferences-dialog.vala"
	_vala_width = _tmp0_;
#line 367 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->paper_size_combo;
#line 367 "../src/preferences-dialog.vala"
	_tmp3_ = gtk_combo_box_get_active_iter (_tmp1_, &_tmp2_);
#line 367 "../src/preferences-dialog.vala"
	iter = _tmp2_;
#line 367 "../src/preferences-dialog.vala"
	if (_tmp3_) {
#line 2158 "preferences-dialog.c"
		GtkListStore* _tmp4_;
		GtkTreeIter _tmp5_;
#line 369 "../src/preferences-dialog.vala"
		_tmp4_ = self->priv->paper_size_model;
#line 369 "../src/preferences-dialog.vala"
		_tmp5_ = iter;
#line 369 "../src/preferences-dialog.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp4_, &_tmp5_, 0, &_vala_width, 1, &_vala_height, -1, -1);
#line 370 "../src/preferences-dialog.vala"
		result = TRUE;
#line 370 "../src/preferences-dialog.vala"
		if (width) {
#line 370 "../src/preferences-dialog.vala"
			*width = _vala_width;
#line 2173 "preferences-dialog.c"
		}
#line 370 "../src/preferences-dialog.vala"
		if (height) {
#line 370 "../src/preferences-dialog.vala"
			*height = _vala_height;
#line 2179 "preferences-dialog.c"
		}
#line 370 "../src/preferences-dialog.vala"
		return result;
#line 2183 "preferences-dialog.c"
	}
#line 373 "../src/preferences-dialog.vala"
	result = FALSE;
#line 373 "../src/preferences-dialog.vala"
	if (width) {
#line 373 "../src/preferences-dialog.vala"
		*width = _vala_width;
#line 2191 "preferences-dialog.c"
	}
#line 373 "../src/preferences-dialog.vala"
	if (height) {
#line 373 "../src/preferences-dialog.vala"
		*height = _vala_height;
#line 2197 "preferences-dialog.c"
	}
#line 373 "../src/preferences-dialog.vala"
	return result;
#line 2201 "preferences-dialog.c"
}


gint
preferences_dialog_get_brightness (PreferencesDialog* self)
{
	gint result = 0;
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 376 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 378 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->brightness_adjustment;
#line 378 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
#line 378 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 378 "../src/preferences-dialog.vala"
	result = (gint) _tmp2_;
#line 378 "../src/preferences-dialog.vala"
	return result;
#line 2224 "preferences-dialog.c"
}


void
preferences_dialog_set_brightness (PreferencesDialog* self,
                                   gint brightness)
{
	GtkAdjustment* _tmp0_;
#line 381 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->brightness_adjustment;
#line 383 "../src/preferences-dialog.vala"
	gtk_adjustment_set_value (_tmp0_, (gdouble) brightness);
#line 2239 "preferences-dialog.c"
}


gint
preferences_dialog_get_contrast (PreferencesDialog* self)
{
	gint result = 0;
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 386 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 388 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->contrast_adjustment;
#line 388 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
#line 388 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 388 "../src/preferences-dialog.vala"
	result = (gint) _tmp2_;
#line 388 "../src/preferences-dialog.vala"
	return result;
#line 2262 "preferences-dialog.c"
}


void
preferences_dialog_set_contrast (PreferencesDialog* self,
                                 gint contrast)
{
	GtkAdjustment* _tmp0_;
#line 391 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 393 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->contrast_adjustment;
#line 393 "../src/preferences-dialog.vala"
	gtk_adjustment_set_value (_tmp0_, (gdouble) contrast);
#line 2277 "preferences-dialog.c"
}


gint
preferences_dialog_get_page_delay (PreferencesDialog* self)
{
	gint result = 0;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 396 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 398 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->page_delay_15s_button;
#line 398 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 398 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 398 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 399 "../src/preferences-dialog.vala"
		result = 15000;
#line 399 "../src/preferences-dialog.vala"
		return result;
#line 2302 "preferences-dialog.c"
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 400 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->page_delay_10s_button;
#line 400 "../src/preferences-dialog.vala"
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
#line 400 "../src/preferences-dialog.vala"
		_tmp5_ = _tmp4_;
#line 400 "../src/preferences-dialog.vala"
		if (_tmp5_) {
#line 401 "../src/preferences-dialog.vala"
			result = 10000;
#line 401 "../src/preferences-dialog.vala"
			return result;
#line 2319 "preferences-dialog.c"
		} else {
			GtkRadioButton* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
#line 402 "../src/preferences-dialog.vala"
			_tmp6_ = self->priv->page_delay_7s_button;
#line 402 "../src/preferences-dialog.vala"
			_tmp7_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp6_);
#line 402 "../src/preferences-dialog.vala"
			_tmp8_ = _tmp7_;
#line 402 "../src/preferences-dialog.vala"
			if (_tmp8_) {
#line 403 "../src/preferences-dialog.vala"
				result = 7000;
#line 403 "../src/preferences-dialog.vala"
				return result;
#line 2336 "preferences-dialog.c"
			} else {
				GtkRadioButton* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
#line 404 "../src/preferences-dialog.vala"
				_tmp9_ = self->priv->page_delay_5s_button;
#line 404 "../src/preferences-dialog.vala"
				_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
#line 404 "../src/preferences-dialog.vala"
				_tmp11_ = _tmp10_;
#line 404 "../src/preferences-dialog.vala"
				if (_tmp11_) {
#line 405 "../src/preferences-dialog.vala"
					result = 5000;
#line 405 "../src/preferences-dialog.vala"
					return result;
#line 2353 "preferences-dialog.c"
				} else {
#line 407 "../src/preferences-dialog.vala"
					result = 3000;
#line 407 "../src/preferences-dialog.vala"
					return result;
#line 2359 "preferences-dialog.c"
				}
			}
		}
	}
}


void
preferences_dialog_set_page_delay (PreferencesDialog* self,
                                   gint page_delay)
{
#line 410 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 412 "../src/preferences-dialog.vala"
	if (page_delay >= 15000) {
#line 2375 "preferences-dialog.c"
		GtkRadioButton* _tmp0_;
#line 413 "../src/preferences-dialog.vala"
		_tmp0_ = self->priv->page_delay_15s_button;
#line 413 "../src/preferences-dialog.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
#line 2381 "preferences-dialog.c"
	} else {
#line 414 "../src/preferences-dialog.vala"
		if (page_delay >= 1000) {
#line 2385 "preferences-dialog.c"
			GtkRadioButton* _tmp1_;
#line 415 "../src/preferences-dialog.vala"
			_tmp1_ = self->priv->page_delay_10s_button;
#line 415 "../src/preferences-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
#line 2391 "preferences-dialog.c"
		} else {
#line 416 "../src/preferences-dialog.vala"
			if (page_delay >= 7000) {
#line 2395 "preferences-dialog.c"
				GtkRadioButton* _tmp2_;
#line 417 "../src/preferences-dialog.vala"
				_tmp2_ = self->priv->page_delay_7s_button;
#line 417 "../src/preferences-dialog.vala"
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
#line 2401 "preferences-dialog.c"
			} else {
#line 418 "../src/preferences-dialog.vala"
				if (page_delay >= 5000) {
#line 2405 "preferences-dialog.c"
					GtkRadioButton* _tmp3_;
#line 419 "../src/preferences-dialog.vala"
					_tmp3_ = self->priv->page_delay_5s_button;
#line 419 "../src/preferences-dialog.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
#line 2411 "preferences-dialog.c"
				} else {
					GtkRadioButton* _tmp4_;
#line 421 "../src/preferences-dialog.vala"
					_tmp4_ = self->priv->page_delay_3s_button;
#line 421 "../src/preferences-dialog.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp4_, TRUE);
#line 2418 "preferences-dialog.c"
				}
			}
		}
	}
}


static void
preferences_dialog_set_dpi_combo (PreferencesDialog* self,
                                  GtkComboBox* combo,
                                  gint default_dpi,
                                  gint current_dpi)
{
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp0_;
	GtkCellRendererText* _tmp1_;
	GtkCellRendererText* _tmp2_;
	GtkListStore* model = NULL;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkListStore* _tmp5_;
	gint* scan_resolutions = NULL;
	gint* _tmp6_;
	gint scan_resolutions_length1;
	gint _scan_resolutions_size_;
	gint* _tmp7_;
	gint _tmp7__length1;
#line 424 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 424 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 426 "../src/preferences-dialog.vala"
	_tmp0_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 426 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 426 "../src/preferences-dialog.vala"
	renderer = _tmp0_;
#line 427 "../src/preferences-dialog.vala"
	_tmp1_ = renderer;
#line 427 "../src/preferences-dialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) combo, (GtkCellRenderer*) _tmp1_, TRUE);
#line 428 "../src/preferences-dialog.vala"
	_tmp2_ = renderer;
#line 428 "../src/preferences-dialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) combo, (GtkCellRenderer*) _tmp2_, "text", 1);
#line 430 "../src/preferences-dialog.vala"
	_tmp3_ = gtk_combo_box_get_model (combo);
#line 430 "../src/preferences-dialog.vala"
	_tmp4_ = _tmp3_;
#line 430 "../src/preferences-dialog.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_list_store_get_type ()) ? ((GtkListStore*) _tmp4_) : NULL);
#line 430 "../src/preferences-dialog.vala"
	model = _tmp5_;
#line 431 "../src/preferences-dialog.vala"
	_tmp6_ = g_new0 (gint, 6);
#line 431 "../src/preferences-dialog.vala"
	_tmp6_[0] = 75;
#line 431 "../src/preferences-dialog.vala"
	_tmp6_[1] = 150;
#line 431 "../src/preferences-dialog.vala"
	_tmp6_[2] = 300;
#line 431 "../src/preferences-dialog.vala"
	_tmp6_[3] = 600;
#line 431 "../src/preferences-dialog.vala"
	_tmp6_[4] = 1200;
#line 431 "../src/preferences-dialog.vala"
	_tmp6_[5] = 2400;
#line 431 "../src/preferences-dialog.vala"
	scan_resolutions = _tmp6_;
#line 431 "../src/preferences-dialog.vala"
	scan_resolutions_length1 = 6;
#line 431 "../src/preferences-dialog.vala"
	_scan_resolutions_size_ = scan_resolutions_length1;
#line 432 "../src/preferences-dialog.vala"
	_tmp7_ = scan_resolutions;
#line 432 "../src/preferences-dialog.vala"
	_tmp7__length1 = scan_resolutions_length1;
#line 2496 "preferences-dialog.c"
	{
		gint* dpi_collection = NULL;
		gint dpi_collection_length1 = 0;
		gint _dpi_collection_size_ = 0;
		gint dpi_it = 0;
#line 432 "../src/preferences-dialog.vala"
		dpi_collection = _tmp7_;
#line 432 "../src/preferences-dialog.vala"
		dpi_collection_length1 = _tmp7__length1;
#line 432 "../src/preferences-dialog.vala"
		for (dpi_it = 0; dpi_it < _tmp7__length1; dpi_it = dpi_it + 1) {
#line 2508 "preferences-dialog.c"
			gint dpi = 0;
#line 432 "../src/preferences-dialog.vala"
			dpi = dpi_collection[dpi_it];
#line 2512 "preferences-dialog.c"
			{
				gchar* label = NULL;
				gint _tmp8_;
				GtkTreeIter iter = {0};
				GtkListStore* _tmp19_;
				GtkTreeIter _tmp20_ = {0};
				GtkListStore* _tmp21_;
				GtkTreeIter _tmp22_;
				gint _tmp23_;
				const gchar* _tmp24_;
				gint _tmp25_;
#line 435 "../src/preferences-dialog.vala"
				_tmp8_ = dpi;
#line 435 "../src/preferences-dialog.vala"
				if (_tmp8_ == default_dpi) {
#line 2528 "preferences-dialog.c"
					gint _tmp9_;
					gchar* _tmp10_;
#line 437 "../src/preferences-dialog.vala"
					_tmp9_ = dpi;
#line 437 "../src/preferences-dialog.vala"
					_tmp10_ = g_strdup_printf (_ ("%d dpi (default)"), _tmp9_);
#line 437 "../src/preferences-dialog.vala"
					_g_free0 (label);
#line 437 "../src/preferences-dialog.vala"
					label = _tmp10_;
#line 2539 "preferences-dialog.c"
				} else {
					gint _tmp11_;
#line 438 "../src/preferences-dialog.vala"
					_tmp11_ = dpi;
#line 438 "../src/preferences-dialog.vala"
					if (_tmp11_ == 75) {
#line 2546 "preferences-dialog.c"
						gint _tmp12_;
						gchar* _tmp13_;
#line 440 "../src/preferences-dialog.vala"
						_tmp12_ = dpi;
#line 440 "../src/preferences-dialog.vala"
						_tmp13_ = g_strdup_printf (_ ("%d dpi (draft)"), _tmp12_);
#line 440 "../src/preferences-dialog.vala"
						_g_free0 (label);
#line 440 "../src/preferences-dialog.vala"
						label = _tmp13_;
#line 2557 "preferences-dialog.c"
					} else {
						gint _tmp14_;
#line 441 "../src/preferences-dialog.vala"
						_tmp14_ = dpi;
#line 441 "../src/preferences-dialog.vala"
						if (_tmp14_ == 1200) {
#line 2564 "preferences-dialog.c"
							gint _tmp15_;
							gchar* _tmp16_;
#line 443 "../src/preferences-dialog.vala"
							_tmp15_ = dpi;
#line 443 "../src/preferences-dialog.vala"
							_tmp16_ = g_strdup_printf (_ ("%d dpi (high resolution)"), _tmp15_);
#line 443 "../src/preferences-dialog.vala"
							_g_free0 (label);
#line 443 "../src/preferences-dialog.vala"
							label = _tmp16_;
#line 2575 "preferences-dialog.c"
						} else {
							gint _tmp17_;
							gchar* _tmp18_;
#line 446 "../src/preferences-dialog.vala"
							_tmp17_ = dpi;
#line 446 "../src/preferences-dialog.vala"
							_tmp18_ = g_strdup_printf (_ ("%d dpi"), _tmp17_);
#line 446 "../src/preferences-dialog.vala"
							_g_free0 (label);
#line 446 "../src/preferences-dialog.vala"
							label = _tmp18_;
#line 2587 "preferences-dialog.c"
						}
					}
				}
#line 449 "../src/preferences-dialog.vala"
				_tmp19_ = model;
#line 449 "../src/preferences-dialog.vala"
				gtk_list_store_append (_tmp19_, &_tmp20_);
#line 449 "../src/preferences-dialog.vala"
				iter = _tmp20_;
#line 450 "../src/preferences-dialog.vala"
				_tmp21_ = model;
#line 450 "../src/preferences-dialog.vala"
				_tmp22_ = iter;
#line 450 "../src/preferences-dialog.vala"
				_tmp23_ = dpi;
#line 450 "../src/preferences-dialog.vala"
				_tmp24_ = label;
#line 450 "../src/preferences-dialog.vala"
				gtk_list_store_set (_tmp21_, &_tmp22_, 0, _tmp23_, 1, _tmp24_, -1, -1);
#line 452 "../src/preferences-dialog.vala"
				_tmp25_ = dpi;
#line 452 "../src/preferences-dialog.vala"
				if (_tmp25_ == current_dpi) {
#line 2611 "preferences-dialog.c"
					GtkTreeIter _tmp26_;
#line 453 "../src/preferences-dialog.vala"
					_tmp26_ = iter;
#line 453 "../src/preferences-dialog.vala"
					gtk_combo_box_set_active_iter (combo, &_tmp26_);
#line 2617 "preferences-dialog.c"
				}
#line 432 "../src/preferences-dialog.vala"
				_g_free0 (label);
#line 2621 "preferences-dialog.c"
			}
		}
	}
#line 424 "../src/preferences-dialog.vala"
	scan_resolutions = (g_free (scan_resolutions), NULL);
#line 424 "../src/preferences-dialog.vala"
	_g_object_unref0 (model);
#line 424 "../src/preferences-dialog.vala"
	_g_object_unref0 (renderer);
#line 2631 "preferences-dialog.c"
}


static void
preferences_dialog_device_combo_changed_cb (PreferencesDialog* self,
                                            GtkWidget* widget)
{
	gboolean _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 458 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/preferences-dialog.vala"
	g_return_if_fail (widget != NULL);
#line 460 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->setting_devices;
#line 460 "../src/preferences-dialog.vala"
	if (_tmp0_) {
#line 461 "../src/preferences-dialog.vala"
		return;
#line 2653 "preferences-dialog.c"
	}
#line 462 "../src/preferences-dialog.vala"
	self->priv->user_selected_device = TRUE;
#line 463 "../src/preferences-dialog.vala"
	_tmp1_ = preferences_dialog_get_selected_device (self);
#line 463 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 463 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 463 "../src/preferences-dialog.vala"
	_g_free0 (_tmp2_);
#line 463 "../src/preferences-dialog.vala"
	if (_tmp3_) {
#line 2667 "preferences-dialog.c"
		GSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 464 "../src/preferences-dialog.vala"
		_tmp4_ = self->priv->settings;
#line 464 "../src/preferences-dialog.vala"
		_tmp5_ = preferences_dialog_get_selected_device (self);
#line 464 "../src/preferences-dialog.vala"
		_tmp6_ = _tmp5_;
#line 464 "../src/preferences-dialog.vala"
		g_settings_set_string (_tmp4_, "selected-device", _tmp6_);
#line 464 "../src/preferences-dialog.vala"
		_g_free0 (_tmp6_);
#line 2681 "preferences-dialog.c"
	}
}


static void
_preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_device_combo_changed_cb ((PreferencesDialog*) self, _sender);
#line 2692 "preferences-dialog.c"
}


static void
preferences_dialog_class_init (PreferencesDialogClass * klass)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PreferencesDialog_private_offset);
#line 14 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/SimpleScan/preferences-dialog.ui");
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "device_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, device_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_scale));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_scale));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "device_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, device_model));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_3s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_3s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_5s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_5s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_7s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_7s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_10s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_10s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_15s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_15s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_model));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_model));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "front_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, front_side_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, back_side_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "both_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, both_side_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_model));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_adjustment));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_adjustment));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "device_combo_changed_cb", G_CALLBACK(_preferences_dialog_device_combo_changed_cb_gtk_combo_box_changed));
#line 2749 "preferences-dialog.c"
}


static void
preferences_dialog_instance_init (PreferencesDialog * self)
{
#line 14 "../src/preferences-dialog.vala"
	self->priv = preferences_dialog_get_instance_private (self);
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2760 "preferences-dialog.c"
}


static void
preferences_dialog_finalize (GObject * obj)
{
	PreferencesDialog * self;
#line 14 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
#line 16 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 22 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->device_combo);
#line 24 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->text_dpi_combo);
#line 26 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->photo_dpi_combo);
#line 28 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->paper_size_combo);
#line 30 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->brightness_scale);
#line 32 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->contrast_scale);
#line 34 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->device_model);
#line 36 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->page_delay_3s_button);
#line 38 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->page_delay_5s_button);
#line 40 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->page_delay_7s_button);
#line 42 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->page_delay_10s_button);
#line 44 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->page_delay_15s_button);
#line 46 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->text_dpi_model);
#line 48 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->photo_dpi_model);
#line 50 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->front_side_button);
#line 52 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->back_side_button);
#line 54 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->both_side_button);
#line 56 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->paper_size_model);
#line 58 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->brightness_adjustment);
#line 60 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->contrast_adjustment);
#line 14 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
#line 2814 "preferences-dialog.c"
}


GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "PreferencesDialog", &g_define_type_info, 0);
		PreferencesDialog_private_offset = g_type_add_instance_private (preferences_dialog_type_id, sizeof (PreferencesDialogPrivate));
		g_once_init_leave (&preferences_dialog_type_id__volatile, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__volatile;
}


static inline gpointer
page_icon_get_instance_private (PageIcon* self)
{
	return G_STRUCT_MEMBER_P (self, PageIcon_private_offset);
}


PageIcon*
page_icon_construct (GType object_type,
                     const gchar* text,
                     gdouble r,
                     gdouble g,
                     gdouble b)
{
	PageIcon * self = NULL;
	gchar* _tmp0_;
#line 476 "../src/preferences-dialog.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 476 "../src/preferences-dialog.vala"
	self = (PageIcon*) g_object_new (object_type, NULL);
#line 478 "../src/preferences-dialog.vala"
	_tmp0_ = g_strdup (text);
#line 478 "../src/preferences-dialog.vala"
	_g_free0 (self->priv->text);
#line 478 "../src/preferences-dialog.vala"
	self->priv->text = _tmp0_;
#line 479 "../src/preferences-dialog.vala"
	self->priv->r = r;
#line 480 "../src/preferences-dialog.vala"
	self->priv->g = g;
#line 481 "../src/preferences-dialog.vala"
	self->priv->b = b;
#line 476 "../src/preferences-dialog.vala"
	return self;
#line 2867 "preferences-dialog.c"
}


PageIcon*
page_icon_new (const gchar* text,
               gdouble r,
               gdouble g,
               gdouble b)
{
#line 476 "../src/preferences-dialog.vala"
	return page_icon_construct (TYPE_PAGE_ICON, text, r, g, b);
#line 2879 "preferences-dialog.c"
}


static void
page_icon_real_get_preferred_width (GtkWidget* base,
                                    gint* minimum_width,
                                    gint* natural_width)
{
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
#line 484 "../src/preferences-dialog.vala"
	self = (PageIcon*) base;
#line 486 "../src/preferences-dialog.vala"
	_vala_natural_width = PAGE_ICON_MINIMUM_WIDTH;
#line 486 "../src/preferences-dialog.vala"
	_vala_minimum_width = _vala_natural_width;
#line 484 "../src/preferences-dialog.vala"
	if (minimum_width) {
#line 484 "../src/preferences-dialog.vala"
		*minimum_width = _vala_minimum_width;
#line 2901 "preferences-dialog.c"
	}
#line 484 "../src/preferences-dialog.vala"
	if (natural_width) {
#line 484 "../src/preferences-dialog.vala"
		*natural_width = _vala_natural_width;
#line 2907 "preferences-dialog.c"
	}
}


static void
page_icon_real_get_preferred_height (GtkWidget* base,
                                     gint* minimum_height,
                                     gint* natural_height)
{
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
#line 489 "../src/preferences-dialog.vala"
	self = (PageIcon*) base;
#line 491 "../src/preferences-dialog.vala"
	_vala_natural_height = (gint) round (PAGE_ICON_MINIMUM_WIDTH * G_SQRT2);
#line 491 "../src/preferences-dialog.vala"
	_vala_minimum_height = _vala_natural_height;
#line 489 "../src/preferences-dialog.vala"
	if (minimum_height) {
#line 489 "../src/preferences-dialog.vala"
		*minimum_height = _vala_minimum_height;
#line 2930 "preferences-dialog.c"
	}
#line 489 "../src/preferences-dialog.vala"
	if (natural_height) {
#line 489 "../src/preferences-dialog.vala"
		*natural_height = _vala_natural_height;
#line 2936 "preferences-dialog.c"
	}
}


static void
page_icon_real_get_preferred_height_for_width (GtkWidget* base,
                                               gint width,
                                               gint* minimum_height,
                                               gint* natural_height)
{
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
#line 494 "../src/preferences-dialog.vala"
	self = (PageIcon*) base;
#line 496 "../src/preferences-dialog.vala"
	_vala_natural_height = (gint) (width * G_SQRT2);
#line 496 "../src/preferences-dialog.vala"
	_vala_minimum_height = _vala_natural_height;
#line 494 "../src/preferences-dialog.vala"
	if (minimum_height) {
#line 494 "../src/preferences-dialog.vala"
		*minimum_height = _vala_minimum_height;
#line 2960 "preferences-dialog.c"
	}
#line 494 "../src/preferences-dialog.vala"
	if (natural_height) {
#line 494 "../src/preferences-dialog.vala"
		*natural_height = _vala_natural_height;
#line 2966 "preferences-dialog.c"
	}
}


static void
page_icon_real_get_preferred_width_for_height (GtkWidget* base,
                                               gint height,
                                               gint* minimum_width,
                                               gint* natural_width)
{
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
#line 499 "../src/preferences-dialog.vala"
	self = (PageIcon*) base;
#line 501 "../src/preferences-dialog.vala"
	_vala_natural_width = (gint) (height / G_SQRT2);
#line 501 "../src/preferences-dialog.vala"
	_vala_minimum_width = _vala_natural_width;
#line 499 "../src/preferences-dialog.vala"
	if (minimum_width) {
#line 499 "../src/preferences-dialog.vala"
		*minimum_width = _vala_minimum_width;
#line 2990 "preferences-dialog.c"
	}
#line 499 "../src/preferences-dialog.vala"
	if (natural_width) {
#line 499 "../src/preferences-dialog.vala"
		*natural_width = _vala_natural_width;
#line 2996 "preferences-dialog.c"
	}
}


static gboolean
page_icon_real_draw (GtkWidget* base,
                     cairo_t* c)
{
	PageIcon * self;
	gboolean result = FALSE;
	gint w = 0;
	gint h = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	cairo_text_extents_t extents = {0};
	const gchar* _tmp11_;
	cairo_text_extents_t _tmp12_ = {0};
	gint _tmp13_;
	cairo_text_extents_t _tmp14_;
	gdouble _tmp15_;
	gint _tmp16_;
	cairo_text_extents_t _tmp17_;
	gdouble _tmp18_;
	const gchar* _tmp19_;
#line 504 "../src/preferences-dialog.vala"
	self = (PageIcon*) base;
#line 504 "../src/preferences-dialog.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 506 "../src/preferences-dialog.vala"
	w = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 507 "../src/preferences-dialog.vala"
	h = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 508 "../src/preferences-dialog.vala"
	_tmp0_ = w;
#line 508 "../src/preferences-dialog.vala"
	_tmp1_ = h;
#line 508 "../src/preferences-dialog.vala"
	if ((_tmp0_ * G_SQRT2) > ((gdouble) _tmp1_)) {
#line 3042 "preferences-dialog.c"
		gint _tmp2_;
#line 509 "../src/preferences-dialog.vala"
		_tmp2_ = h;
#line 509 "../src/preferences-dialog.vala"
		w = (gint) round (_tmp2_ / G_SQRT2);
#line 3048 "preferences-dialog.c"
	} else {
		gint _tmp3_;
#line 511 "../src/preferences-dialog.vala"
		_tmp3_ = w;
#line 511 "../src/preferences-dialog.vala"
		h = (gint) round (_tmp3_ * G_SQRT2);
#line 3055 "preferences-dialog.c"
	}
#line 513 "../src/preferences-dialog.vala"
	_tmp4_ = w;
#line 513 "../src/preferences-dialog.vala"
	_tmp5_ = h;
#line 513 "../src/preferences-dialog.vala"
	cairo_translate (c, (gdouble) ((gtk_widget_get_allocated_width ((GtkWidget*) self) - _tmp4_) / 2), (gdouble) ((gtk_widget_get_allocated_height ((GtkWidget*) self) - _tmp5_) / 2));
#line 515 "../src/preferences-dialog.vala"
	_tmp6_ = w;
#line 515 "../src/preferences-dialog.vala"
	_tmp7_ = h;
#line 515 "../src/preferences-dialog.vala"
	cairo_rectangle (c, 0.5, 0.5, (gdouble) (_tmp6_ - 1), (gdouble) (_tmp7_ - 1));
#line 517 "../src/preferences-dialog.vala"
	_tmp8_ = self->priv->r;
#line 517 "../src/preferences-dialog.vala"
	_tmp9_ = self->priv->g;
#line 517 "../src/preferences-dialog.vala"
	_tmp10_ = self->priv->b;
#line 517 "../src/preferences-dialog.vala"
	cairo_set_source_rgb (c, _tmp8_, _tmp9_, _tmp10_);
#line 518 "../src/preferences-dialog.vala"
	cairo_fill_preserve (c);
#line 520 "../src/preferences-dialog.vala"
	cairo_set_line_width (c, 1.0);
#line 521 "../src/preferences-dialog.vala"
	cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
#line 522 "../src/preferences-dialog.vala"
	cairo_stroke (c);
#line 525 "../src/preferences-dialog.vala"
	_tmp11_ = self->priv->text;
#line 525 "../src/preferences-dialog.vala"
	cairo_text_extents (c, _tmp11_, &_tmp12_);
#line 525 "../src/preferences-dialog.vala"
	extents = _tmp12_;
#line 526 "../src/preferences-dialog.vala"
	_tmp13_ = w;
#line 526 "../src/preferences-dialog.vala"
	_tmp14_ = extents;
#line 526 "../src/preferences-dialog.vala"
	_tmp15_ = _tmp14_.width;
#line 526 "../src/preferences-dialog.vala"
	_tmp16_ = h;
#line 526 "../src/preferences-dialog.vala"
	_tmp17_ = extents;
#line 526 "../src/preferences-dialog.vala"
	_tmp18_ = _tmp17_.height;
#line 526 "../src/preferences-dialog.vala"
	cairo_translate (c, ((_tmp13_ - _tmp15_) * 0.5) - 0.5, ((_tmp16_ + _tmp18_) * 0.5) - 0.5);
#line 527 "../src/preferences-dialog.vala"
	_tmp19_ = self->priv->text;
#line 527 "../src/preferences-dialog.vala"
	cairo_show_text (c, _tmp19_);
#line 529 "../src/preferences-dialog.vala"
	result = TRUE;
#line 529 "../src/preferences-dialog.vala"
	return result;
#line 3113 "preferences-dialog.c"
}


static void
page_icon_class_init (PageIconClass * klass)
{
#line 468 "../src/preferences-dialog.vala"
	page_icon_parent_class = g_type_class_peek_parent (klass);
#line 468 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PageIcon_private_offset);
#line 468 "../src/preferences-dialog.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) page_icon_real_get_preferred_width;
#line 468 "../src/preferences-dialog.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) page_icon_real_get_preferred_height;
#line 468 "../src/preferences-dialog.vala"
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) page_icon_real_get_preferred_height_for_width;
#line 468 "../src/preferences-dialog.vala"
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget*, gint, gint*, gint*)) page_icon_real_get_preferred_width_for_height;
#line 468 "../src/preferences-dialog.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) page_icon_real_draw;
#line 468 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = page_icon_finalize;
#line 3136 "preferences-dialog.c"
}


static void
page_icon_instance_init (PageIcon * self)
{
#line 468 "../src/preferences-dialog.vala"
	self->priv = page_icon_get_instance_private (self);
#line 3145 "preferences-dialog.c"
}


static void
page_icon_finalize (GObject * obj)
{
	PageIcon * self;
#line 468 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_ICON, PageIcon);
#line 470 "../src/preferences-dialog.vala"
	_g_free0 (self->priv->text);
#line 468 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (page_icon_parent_class)->finalize (obj);
#line 3159 "preferences-dialog.c"
}


GType
page_icon_get_type (void)
{
	static volatile gsize page_icon_type_id__volatile = 0;
	if (g_once_init_enter (&page_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PageIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageIcon), 0, (GInstanceInitFunc) page_icon_instance_init, NULL };
		GType page_icon_type_id;
		page_icon_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PageIcon", &g_define_type_info, 0);
		PageIcon_private_offset = g_type_add_instance_private (page_icon_type_id, sizeof (PageIconPrivate));
		g_once_init_leave (&page_icon_type_id__volatile, page_icon_type_id);
	}
	return page_icon_type_id__volatile;
}



